HDU-2955 Robberies (01背包)

题目:

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.
For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.
His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each
scenario, the first line of input gives a floating point number P, the
probability Roy needs to be below, and an integer N, the number of
banks he has plans for. Then follow N lines, where line j gives an
integer Mj and a floating point number Pj . Bank j contains Mj
millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.
Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output

2
4
6

思路:

这题难点在于背包容量和价值如何取,我这里是把最大可抢金额数当作容量, 把(1-被抓概率)即逃跑概率当作价值,因为这样可以往大取。

This is Code:

 1 #include<bits/stdc++.h>
 2 using namespace std;
 3 float dp[15000];
 4 
 5 typedef struct{
 6     int val;
 7     float cost;
 8 }node;
 9 
10 void zeroonebag(node a, int n){
11     for (int i = n; i >= a.val; i--)
12         dp[i] = max(dp[i-a.val]*a.cost, dp[i]);
13 }
14 
15 int main()
16 {
17     int T, n;
18     double P;
19     node b[150];
20     cin>>T;
21     while(T--){
22         int maxsum = 0;
23         cin>>P>>n;
24         memset(dp, 0, sizeof(dp));
25         dp[0] = 1;//初始化由于没偷任何东西时逃脱概率为1,其他概率为0
26         for (int i = 0; i < n; i++){
27             cin>>b[i].val>>b[i].cost;
28             b[i].cost = 1 - b[i].cost;
29             maxsum += b[i].val;
30         }
31         for (int i = 0; i < n; i++)
32             zeroonebag(b[i], maxsum);
33         for (int i = maxsum; i >= 0; i--){
34             if (dp[i] >= 1-P){
35                 cout<<i<<endl;
36                 break;
37             }
38         }
39     }
40 
41     return 0;
42 }
原文地址:https://www.cnblogs.com/robin1998/p/6359135.html